#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

/* This example has to run with 4 mpi instances */

int main(int argc, char *argv[]) 
{
  int err, k;
  int Number_of_Processes, task, i;
  int global_numbers[32], local_numbers[8];
    
  err = MPI_Init(&argc, &argv);
  
  MPI_Comm_size(MPI_COMM_WORLD, &Number_of_Processes);
  MPI_Comm_rank(MPI_COMM_WORLD, &task);  
  
  k=0;
  for(i=task*8; i<(task*8 + 8); i++)
    {
      local_numbers[k] = i;
      k++;
    }
  
  MPI_Barrier(MPI_COMM_WORLD);
  
  for(i=0; i<Number_of_Processes; i++)
    {
      
      if(i == task)
	{
	  for(k=0; k<8; k++)
	    printf("task %d input %d\n",task, local_numbers[k]);
	}
      
      MPI_Barrier(MPI_COMM_WORLD);
    }

  
  MPI_Gather(&local_numbers[0], 8, MPI_INT, &global_numbers[0], 8, MPI_INT, 0, MPI_COMM_WORLD);
  
  if(task == 0)
    {
      for(i=0; i<32; i++)
	printf("Now in task 0 we have %d\n",global_numbers[i]);
    }
  
  MPI_Barrier(MPI_COMM_WORLD);
  
  err = MPI_Finalize();
  
}
