#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

int main (int argc, char *argv[]) 
{
  
  int err, k, alltasks=0;
  int Number_of_Processes, task, i;
  int results[8], local_numbers[8];
  
  err = MPI_Init(&argc, &argv);
  
  MPI_Comm_size(MPI_COMM_WORLD, &Number_of_Processes);
  MPI_Comm_rank(MPI_COMM_WORLD, &task);
  
  k=0;
  for(i=task*8; i<(task*8 + 8); i++)
    {
      local_numbers[k] = i;
      k++;
    }
  MPI_Barrier(MPI_COMM_WORLD);
  
  for(i=0; i<Number_of_Processes; i++)
    {
      
      if(i == task)
	{
	  for(k=0; k<8; k++)
	    printf("task %d input %d\n",task, local_numbers[k]);
	}
      
      MPI_Barrier(MPI_COMM_WORLD);
    }
  
  for(i=0; i<8; i++)
    results[i] = 0;
  
  MPI_Reduce(&local_numbers[0], &results[0], 8, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);
  
  if(task == 0)
    {
      for(i=0; i<8; i++)
	printf("%d\n",results[i]);
    }
  
  err = MPI_Finalize();
  
}
